/* Flowmeter by A.SAMIUDDHIN */

#include <LiquidCrystal.h>
LiquidCrystal lcd(12, 11, 10, 9, 8, 7);
unsigned long flow=0;
float Litres;

void setup()
{
  lcd.begin(16,2);
  attachInterrupt(digitalPinToInterrupt(2), isr, FALLING);
  lcd_initialize();
}

void loop()
{
  byte count = 0;
  byte digits = 6;
  long buff;
  Litres = flowmeasure()/1000.0;
  buff = Litres;
  if(buff == 0)
  {
    count = 1;
  }
  while(buff!=0)
  {
    count++;
    buff /=10;
  }
  digits = digits - count;
  lcd.setCursor(digits,1);
  lcd.print(Litres, 3);
  count = 0;
  if(flow>=449999550)
  {
    flow = 0UL;
    lcd.clear();
    delay(100);
    lcd_initialize();
  }
}

void isr()
{
  flow++;
}

float flowmeasure()
{
  float flowcount;
  flowcount = (flow/0.45);
  return flowcount;
}

void lcd_initialize()
{
  lcd.setCursor(0,0);
  lcd.print("LITRES  CONSUMED");
  lcd.setCursor(0,1);
  lcd.print("000000.000Litres");  
}
